# grunt-ws-rjs-builder

Паковка `sbis3` модулей и зависимостей  помощью `r.js`

## Как пользоваться?

Если вы не пользовались [Grunt](http://gruntjs.com/), то стоит прочитать небольшой мануал [Getting Started](http://gruntjs.com/getting-started).
В нем описано как создать [Gruntfile](http://gruntjs.com/sample-gruntfile), как устанавливать и использовать плагины для Grunt.

Для установки плагина используйте команду ниже:

    npm install grunt-ws-rjs-builder --save-dev

После того как плагин установлен он становится доступен в вашем Grunfile:

    grunt.loadNpmTasks('grunt-ws-rjs-builder');

Запустите задачу с помощью команды

    grunt ws-rjs-build

Таски и опции могут быть указаны в соответствии с мануалом [Configuring tasks](http://gruntjs.com/configuring-tasks)

### Опции

`root` - корень приложения`*`
`ws` - путь до папки ws относительно корня приложения (по умолчанию `ws`)
`resources` - путь до ресурсов относительно корня приложения (по умолчанию `resources`)
`paths` - дополнительный мапинг для модулей
`name` - имя основного модуля, для которого собираются зависимости`*`
`include` - список дополнительных модулей, которые необходимо включить в пакет
`out` - имя выходного файла относительно корня приложения`*`

`*` - обязательные параметры

## Пример

`Gruntfile.js`

    var path = require('path');

    module.exports = function (grunt) {
       grunt.initConfig({
          "pkg": grunt.file.readJSON('package.json'),
          "rjs-build": {
             data: {
                root: __dirname,
                ws: 'ws',
                resources: 'static',
                paths: {
                   'webrtc' : 'static/startup'
                },
                name: 'webrtc!js!SBIS3.WebRTC.Listener',
                include: [
                   'webrtc!js!SBIS3.WebRTC.Report',
                   'webrtc!js!SBIS3.WebRTC.DataProvider',
                   'webrtc!js!SBIS3.WebRTC.Manager',
                   'webrtc!js!SBIS3.WebRTC.GUI'
                ],
                out: "static/build/main.min.js"
             }
          }
       });

       grunt.loadNpmTasks('grunt-ws-rjs-builder');

       grunt.registerTask('default', ['rjs-build']);
    };

После успешного выполнения таска мы получим 2 пакета `static/build/main.min.js` и `static/build/main.min.css`